/****************************************************************************
 * (c) 2018 softwareentwicklung-als-prozess.de
 * Funktionalitaet:
 * Aktuator schalten und ueberwachen
 ***************************************************************************/
// Includes -----------------------------------------------------------------
#include "vmess.h"
#include "imess.h"
#include "tmess.h"
#include "vibe.h"

// Defines ------------------------------------------------------------------
#define SCHALTZEIT_IN_MS 2

// Variablen ----------------------------------------------------------------
const int motorPin = 3;
const int keypin   = 4;
bool singleon  = true;
bool singleoff = true;
SpannungsStatus vstat = normal;
StromStatus     astat = kein;
TempStatus      tstat = ok;
VibeStatus    vibstat = keine;

// interne Prototypen -------------------------------------------------------

// Funktionen ---------------------------------------------------------------
void setup()
{
  Serial.begin(9600);
  Serial.println("Aktuator schalten und ueberwachen");

  pinMode(motorPin, OUTPUT);
  pinMode(keypin, INPUT);
}

void loop()                       // Motor schalten und Sensoren auswerten
{
  if (digitalRead(keypin) == LOW) // Taste gedrueckt
  { 
    digitalWrite(motorPin, HIGH); // Motor an
    delay(SCHALTZEIT_IN_MS);      // Schaltvorgang abwarten
    vstat = SystemSpannungsUeberwachung();
    if (singleon == true)
    {
      Serial.println("");
      Serial.println("Motor an");
      Serial.println("... das entspricht:");
      switch(vstat)
      {
        case normal:
          Serial.println("- Spannung Normal");
          break;
        case niedrig:
          Serial.println("- Spannung Niedrig");
          break;
        case zuniedrig:
          Serial.println("- Spannung Zu Niedrig");
          break;
      }
      astat = SystemStromUeberwachung();
      switch(astat)
      {
        case kein:
          Serial.println("- Kein Strom");
          break;        
        case mindest:
          Serial.println("- Mindeststrom");
          break;        
        case minder:
          Serial.println("- Minderstrom");
          break;        
        case nenn:
          Serial.println("- Nennstrom");
          break;        
      }
      vibstat = SystemVibeUeberwachung();
      switch(vibstat)
      {
        case keine:
          Serial.println("- keine Vibration");
          break;
        case vibration:
          Serial.println("- Es vibriert ...");
          break;
      }
      tstat = SystemTemperaturUeberwachung();
      switch(tstat)
      {
        case normal:
          Serial.println("- Normaltemperatur");
          break;
        case vibration:
          Serial.println("- Ueberhitzt!");
          break;
      }
      singleon  = false;
      singleoff = true;
    }
  }
  else                            // sonst
  {
    digitalWrite(motorPin, LOW);  // Motor aus
    delay(SCHALTZEIT_IN_MS);      // Schaltvorgang abwarten
    vstat = SystemSpannungsUeberwachung();
    if (singleoff == true)
    {
      Serial.println("");
      Serial.println("Motor aus");
      Serial.println("... das entspricht:");
      switch(vstat)
      {
        case normal:
          Serial.println("- Spannung Normal");
          break;
        case niedrig:
          Serial.println("- Spannung Niedrig");
          break;
        case zuniedrig:
          Serial.println("- Spannung Zu Niedrig");
          break;
      }
      astat = SystemStromUeberwachung();
      switch(astat)
      {
        case kein:
          Serial.println("- Kein Strom");
          break;        
        case mindest:
          Serial.println("- Mindeststrom");
          break;        
        case minder:
          Serial.println("- Minderstrom");
          break;        
        case nenn:
          Serial.println("- Nennstrom");
          break;        
      }
      delay(100); // ausschwingen lassen
      vibstat = SystemVibeUeberwachung();
      switch(vibstat)
      {
        case keine:
          Serial.println("- keine Vibration");
          break;
        case vibration:
          Serial.println("- Es vibriert ...");
          break;
      }
      tstat = SystemTemperaturUeberwachung();
      switch(tstat)
      {
        case normal:
          Serial.println("- Normaltemperatur");
          break;
        case vibration:
          Serial.println("- Ueberhitzt!");
          break;
      }
      singleon  = true;
      singleoff = false;;
    }
  }
}

