/****************************************************************************
 * (c) 2018 softwareentwicklung-als-prozess.de
 * Funktionalitaet:
 * Spannung ueberwachen
 ***************************************************************************/
// Includes -----------------------------------------------------------------
#include <arduino.h>
#include "vmess.h"

// Defines ------------------------------------------------------------------
// vorlaeufige definitionen
#define LOW_LEVEL   3.0
#define TOLOW_LEVEL 2.5

// Variablen ----------------------------------------------------------------
// interne Prototypen -------------------------------------------------------
static float SystemVoltage(void);

// Funktionen ---------------------------------------------------------------
SpannungsStatus SystemSpannungsUeberwachung(void)
{
  float Spannung = 0.0;
  SpannungsStatus retval = normal;

  Spannung = SystemVoltage();
  if (Spannung > LOW_LEVEL)
  {
    retval = normal;
  }
  else
  {
    if (Spannung > TOLOW_LEVEL)
    {
      retval = niedrig;
    }
    else
    {
      retval = zuniedrig;
    }
  }
  return(retval);
}

static float SystemVoltage(void)
{
  float voltage     = 0.0;
  
  voltage = (float)analogRead(A0) * (5.0 / 1023.0);
  return(voltage);
}
